#include<Servo.h>
#include<Wire.h>
#include <IRremote.h>

//Left Motor pins
#define pin1  2
#define pin2  3
#define pin3  4
#define pin4  5

//Right Motor pins
#define pin5  6
#define pin6  7
#define pin7  8
#define pin8  9

//#define enb 6
//#define in4 4
//#define in3 3
//#define in2 2
//#define in1 7
//#define ena 5


//delay between each step
#define delaytime 8

//pump enable pin and input pin
#define pumpEna 10
#define pumpIn1 13

//servo pin
#define servoPin 11

//ir sensor pin
#define ir 12

Servo servo;
IRrecv irrecv(ir);
decode_results results;

int numberOfSteps = 512;

int pourTime = 1000;
int inOut = 1; //determines state of cupholder either outside or inside bot
void setup() {
  pinMode(pin1, OUTPUT);
  pinMode(pin2, OUTPUT);
  pinMode(pin3, OUTPUT);
  pinMode(pin4, OUTPUT);

  pinMode(pin5, OUTPUT);
  pinMode(pin6, OUTPUT);
  pinMode(pin7, OUTPUT);
  pinMode(pin8, OUTPUT);

  //Enable pins for DC water pump
  pinMode(pumpEna, OUTPUT);
  pinMode(pumpIn1, OUTPUT);


  servo.attach(servoPin);
  servo.write(0);

  irrecv.enableIRIn();

  Serial.begin(9600);
}

void loop() {
 //takes code from remote and decodes results
  if (irrecv.decode(&results))
  {
    Serial.println(results.value, HEX);
    switch (results.value)
    {
      //Remote button codes
      case 0xFF18E7: //2
        Serial.println("forward");
        forward(numberOfSteps);
        break;
      case 0xFF4AB5: //8
        Serial.println("backward");
        backward(numberOfSteps);
        break;
      case 0xFF10EF: //4
        Serial.println("left");
        left(numberOfSteps);
        break;
      case 0xFF5AA5: //6
        Serial.println("right");
        right(numberOfSteps);
        break;
      case 0xFF38C7: //5
        Serial.println("cupholder");
        if(inOut == 0)
        {
          servo.write(-180);
          inOut = 1;
        }
        else if(inOut == 1)
        {
          servo.write(180);
          inOut = 0;
        }
        delay(1000);
        break;
      case 0xFF6897: //0
        Serial.println("pump");
        pour();
        break;
    }
    irrecv.resume();
  }

}
